﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace Laboratoire
{
    /// <summary>
    /// Logique d'interaction pour Multi_combo_binder.xaml
    /// </summary>
    public partial class Multi_combo_binder : Window
    {
        public Multi_combo_binder()
        {
            InitializeComponent();
            this.cbMarque.ItemsSource = Marque.Marques;
            this.lvListing.ItemsSource = new ObservableCollection<Voiturette>() { new Voiturette() { nomVoiturette = "R5", marque = Renault.RENAULT }, new Voiturette() { nomVoiturette = "205", marque = Peugeot.PEUGEOT }, new Voiturette() { nomVoiturette = "R21", marque = Renault.RENAULT } };
        }

        private void cbMarque_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            if (this.lvListing.SelectedItem != null)
                ((Voiturette)this.lvListing.SelectedItem).marque = (Marque)this.cbMarque.SelectedItem;
        }
    }

    public abstract class Marque
    {
        public static ObservableCollection<Marque> Marques = new ObservableCollection<Marque>() { Renault.RENAULT, Peugeot.PEUGEOT };
        public virtual ObservableCollection<MesCouleurs> Couleurs { get; set; }
    }

    public class Voiturette : INotifyPropertyChanged
    {
        public string nomVoiturette { get; set; }

        private Marque _marque;
        public Marque marque
        {
            get { return _marque; }
            set
            {
                if (_marque != value)
                {
                    _marque = value;
                    NotifyPropertyChange("marque");
                }
            }
        }

        #region INotifyPropertyChanged Membres
        public event PropertyChangedEventHandler PropertyChanged;
        private void NotifyPropertyChange(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }

    public class MesCouleurs
    {
        public string nomCouleur { get; set; }
    }

    public class Red : MesCouleurs
    {
        private Red() { this.nomCouleur = "Red"; }
        public static Red ROUGE = new Red();

    }

    public class Yellow : MesCouleurs
    {
        private Yellow() { this.nomCouleur = "Yellow"; }
        public static Yellow JAUNE = new Yellow();
    }

    public class Peugeot : Marque
    {
        private Peugeot() { }
        public static Peugeot PEUGEOT = new Peugeot();
        public override ObservableCollection<MesCouleurs> Couleurs
        {
            get
            {
                return new ObservableCollection<MesCouleurs>() { Yellow.JAUNE };
            }
            set { }
        }
    }

    public class Renault : Marque
    {
        private Renault() { }
        public static Renault RENAULT = new Renault();
        public override ObservableCollection<MesCouleurs> Couleurs
        {
            get
            {
                return new ObservableCollection<MesCouleurs>() { Red.ROUGE, Yellow.JAUNE };
            }
            set { }
        }
    }
}
